--
-- 3store: table-version 6
--

CREATE TABLE settings (
  `key` char(32) NOT NULL,
  `value` char(224) NOT NULL,
  PRIMARY KEY(`key`)
) TYPE=MyISAM;

CREATE TABLE symbols (
  hash bigint(20) NOT NULL default '0',
  lexical text NOT NULL,
  ebv $booltype$ default NULL,
  datatype int(11) NOT NULL default '0',
  language int(11) NOT NULL default '0',
  KEY (hash),
  KEY lexical (lexical(255))
) TYPE=MyISAM;

CREATE TABLE datatypes (
  id int(11) NOT NULL auto_increment,
  uri text NOT NULL,
  PRIMARY KEY  (id),
  KEY uri (uri(255))
) TYPE=MyISAM;

CREATE TABLE languages (
  id int(11) NOT NULL auto_increment,
  lang char(5) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY lang (lang)
) TYPE=MyISAM;

CREATE TABLE triples (
  model bigint(20) NOT NULL default '0',
  subject bigint(20) NOT NULL default '0',
  predicate bigint(20) NOT NULL default '0',
  object bigint(20) NOT NULL default '0',
  KEY model (model),
  KEY subject (subject),
  KEY predicate (predicate),
  KEY object (object)
) TYPE=MyISAM;

CREATE TABLE `val_i` (
  `hash` bigint NOT NULL default '0',
  `val` int(11) NOT NULL default '0',
  PRIMARY KEY `hash` (`hash`),
  KEY `val` (`val`)
) ENGINE=MyISAM;

CREATE TABLE `val_f` (
  `hash` bigint NOT NULL default '0',
  `val` double NOT NULL default '0',
  PRIMARY KEY `hash` (`hash`),
  KEY `val` (`val`)
) ENGINE=MyISAM;

CREATE TABLE `val_d` (
  `hash` bigint NOT NULL default '0',
  `val` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY `hash` (`hash`),
  KEY `val` (`val`)
) ENGINE=MyISAM;
