#ifndef INFERENCE_H
#define INFERENCE_H

/* Control Functions */

/* create environment for inference caches to be filled. Must be called before
 * any of the functions that perform inference */
void ts_inference_setup(ts_connection *c, ts_hash model);

/* commit the inferred triples to the triples table */
void ts_inference_commit(ts_connection *c);

/* Inference Functions */

/* Generate transitive closure of the taxonomic predicates */
void ts_rebuild_taxonomy(ts_connection* db, int verbosity);

/* Run the simple rules in rdfs-rules directory */
void ts_run_pending_inference(ts_connection *c);

#endif
