#!/usr/bin/perl -w

$state = "input";

@input = ();
@output = ();

%prefix = (
	"rdf" => "http://www.w3.org/1999/02/22-rdf-syntax-ns#",
	"rdfs" => "http://www.w3.org/2000/01/rdf-schema#",
	"owl" => "http://www.w3.org/2002/07/owl#",
	"direct" => "http://triplestore.aktors.org/direct/#"
);

%uris = ();

while (<>) {
	if (/=>/) {
		$state = "output";
		next;
	}
	if (/--/) {
		&dump_rule;
		$state = "input";
		@input = ();
		@output = ();
		next;
	}
	if (/^#\s*(.*)/) {
		print "/* $1 */\n";
		next;
	}
	if (/^\s*$/) {
		next;
	}
		
	chomp;
	my @a = split(" ", $_);
	push(@$state, \@a);
}

if (@input) {
	&dump_rule;
}

for $u (keys %uris) {
	print "ts_ensure_resource(c, \"$u\");\n";
}

sub dump_rule {
	@lsn = ("subject", "predicate", "object", "inf");
	@ssn = ("s", "p", "o", "");

	@ssn1 = ("p1.s", "p1.p", "p1.o", "");
	@ssn2 = ("p2.s", "p2.p", "p2.o", "");

	if (@input > 1) {
		$slots[0] = \@lsn;
		$slots[1] = \@ssn;
		@table = ("triples", "pending");
		&gen;

		$slots[0] = \@ssn;
		$slots[1] = \@lsn;
		@table = ("pending", "triples");
		&gen;
	}

	$slots[0] = \@ssn1;
	$slots[1] = \@ssn2;
	@table = ("pending as p1", "pending as p2");
	&gen;
}

sub gen {
	%bindings = ();
	@constr = ();
	$c = 0;

	for $in (@input) {
		for $slot (0..2) {
			if ($in->[$slot] =~ /^(([a-zA-Z])\2\2)/) {
				if ($bindings{$1}) {
					push(@constr, $slots[$c]->[$slot]." = ".$bindings{$1});
				} else {
					$bindings{$1} = $slots[$c]->[$slot];
				}
			}
		}
# This prevents rule recursion...
#		if ($slots[$c]->[3]) {
#			push(@constr, $slots[$c]->[3]." = 0");
#		}
		$c++;
	}

	if ($table[0] =~ /^pending/ && $table[1] =~ /^pending/ && @input > 1) {
		#see http://mysql.binarycompass.org/doc/refman/5.0/en/open-bugs.html - ERROR 1137: Can't reopen table
		print("//XXX ");
	}
	print "ts_mysql_query(c->db, \"INSERT INTO infered SELECT \@pmodel, ";
	if ($table[0] eq "triples" || $table[1] eq "triples") {
		print "model, ";
	} else {
		print "1, ";
	}

	for $out (@output) {
		for $slot (0..2) {
			if ($slot) { print ", " };
			if ($bindings{$out->[$slot]}) {
				print $bindings{$out->[$slot]};
				push(@constr, $bindings{$out->[$slot]}." < 0");
			} else {
				print "".&hash($out->[$slot]);
				$uris{&qname($out->[$slot])} = 1;
			}
		}
	}

	print " FROM $table[0]";
	if (@input > 1) {
		print ", $table[1]";
	}
	print " WHERE ";

	$c = 0;
	$cc = 0;
	for $in (@input) {
		for $slot (0..2) {
			if ($in->[$slot] !~ /^(([a-zA-Z])\2\2)/) {
				if ($cc++ > 0) {
					print " AND ";
				}
				print $slots[$c]->[$slot]." = ".&hash($in->[$slot]);
			}
		}
		$c++;
	}

	for $c (@constr) {
		print " AND ";
		print $c;
	}
	print "\");\n";
}

sub hash {
	local($q) = @_;

	$uri = &qname($q);

	$hash = `ts-hash '<$uri>'`;
	$hash =~ m/\((.*)\)/;

	return $1;
}

sub qname {
	local($q) = @_;

	for $p (keys %prefix) {
		$puri = $prefix{$p};
		$q =~ s/^$p:/$puri/;
	}

	return $q;
}
