#ifndef UTIL_H
#define UTIL_H

#include <stdint.h>
#include <glib.h>

#include "tstore.h"

void ts_list_replace_str(GSList *l, const char *from, const char *to);

int ts_sql_count(void *db, const char *q);

/* Mirrors mysql_query, but prints out diagnositic if an error occurs */
#define ts_mysql_query(db, q) ts_mysql_query_intl(db, q, __FILE__, __LINE__)
int ts_mysql_query_intl(MYSQL *db, const char *query, const char *file, const int line);

/* Takes a URI or file path, and returns it normalised to a URI */
char *ts_path_to_uri(char *path);

/* Increases the AUTO_INCREMENT values for a table and returns the next safe
 * value to use */
uint32_t ts_claim_ai_vals(ts_connection *c, char *table, char *column, int size);

int ts_physical_ram(long long *total, long long *free);

void ts_sql_processlist(ts_connection *c);

/* function that call be passed to g_hash_table_new_full to free up malloc'd entries */
void ts_entry_free(gpointer data);

#endif
